#include "messages.h"
#include "str_utils.h"
#include "stg_graph_cluster_dot.h"
#include "g2dot_params.h"

int main (int argc, char** argv)
{
  Progress("Reading command line parameters");
  if (g2dot_process_params(argc, argv))
  {
    Progress("Creating STG object");
    GraphClusterDot* stg = new GraphClusterDot(_g2dot_input_file_names);
    Progress("Read STG");
    stg->readAstg(_g2dot_input_file_names);
    Progress("Calc clusters");
    stg->calcClusters();
    Progress("Write copy STG in DOT format");
    stg->writeDot(_g2dot_output_file_name, _g2dot_legend);
    Progress("Cleaning up STG object");
    delete stg;
  }
  Progress("Cleaning up command line parameters");
  g2dot_clear_params();
  Progress("Done");
  return 0;
}
