#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "g2dot_msgs.h"

const char* _g2dot_fmt_help =
  "A tool for drawing STGs using GraphVis DOT format\n"
  "Usage: %s [OPTIONS] [INPUT_FILE_NAMES]\n"
  "  -o,  --output OUTPUT_FILE_NAME  STG output file [STDOUT]\n"
  "  -l,  --legend                   show legend\n"
  "  -h,  --help                     print this help only\n"
  "  -v,  --version                  print version only\n";
const char* _g2dot_fmt_version =
  "Version %d.%d\n"
  "Last changed at %s\n"
  "Created by Danil Sokolov (E-mail: danil.sokolov@ncl.ac.uk, ICQ#: 30193190)\n"
  "Copyright (c) 2003, University of Newcastle, Newcastle upon Tyne, UK\n";

const int _g2dot_version_major = 2;
const int _g2dot_version_minor = 0;
const char* _g2dot_version_date = "23 March 2006";

//---------------------------------------------------------------------------
char* g2dot_get_help(char* name)
{
  int len = strlen (_g2dot_fmt_help) + 2 * strlen (name) + 1;
  char* help = new char [len];
  sprintf(help, _g2dot_fmt_help, name, name);
  return help;
}

//---------------------------------------------------------------------------
char* g2dot_get_version(char* name)
{
  int len = strlen (_g2dot_fmt_version) + strlen (_g2dot_version_date) + 1;
  char* version = new char [len];
  sprintf(version, _g2dot_fmt_version, _g2dot_version_major, 
    _g2dot_version_minor, _g2dot_version_date);
  return version;
}

