#include "messages.h"
#include "str_utils.h"
#include "stg_graph_protode.h"
#include "protode_params.h"

int main (int argc, char** argv)
{
  Progress("Reading command line parameters");
  if (protode_process_params(argc, argv))
  {
    Progress("Creating STG object");
    GraphProtode* stg = new GraphProtode(_protode_input_file_names);
    Progress("Read STG");
    stg->readAstg(_protode_input_file_names);
    Progress("Define protocol signals");
    stg->addProtocolsDevEnv();
    stg->addProtocolsSets(_protode_protocol_signals);
    stg->calcProtocols();
    Progress("Set protocols types");
    stg->setProtocolsExtract(_protode_protocols_extract);
    stg->setProtocolsExtract(_protode_protocols_optimise_a);
    stg->setProtocolsExtract(_protode_protocols_optimise_ab);
    stg->setProtocolsExtract(_protode_protocols_optimise_abc);
    stg->setProtocolsExtract(_protode_protocols_write);
    stg->setProtocolsOptimise(_protode_protocols_optimise_a, 1);
    stg->setProtocolsOptimise(_protode_protocols_optimise_ab, 2);
    stg->setProtocolsOptimise(_protode_protocols_optimise_abc, 3);
    stg->setProtocolsWrite(_protode_protocols_write);
    Progress("Extract protocols");
    if (stg->checkProtocols())
    {
      stg->extractProtocols();
      stg->optimiseProtocols();
    }
    else
      Error("cannot extract protocols");
    Progress("Write STG");
    stg->writeProtocolsAstg(_protode_output_file_name, _protode_implicit_places);
    Progress("Cleaning up STG object");
    delete stg;
  }
  Progress("Cleaning up command line parameters");
  protode_clear_params();
  Progress("Done");
  return 0;
}
