#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "protode_msgs.h"

const char* _protode_fmt_help =
  "ProtoDe is a tool for protocol decomposition of Signal Transition Graphs\n"
  "Usage: %s [OPTIONS] [INPUT_FILE_NAMES]\n"
  "  -o,  --output OUTPUT_FILE_NAME     STG output file [STDOUT]\n"
  "  -p,  --protocols PROTOCOLS         definition of protocols\n"
  "       PROTOCOLS is a semicolon-separated list of PROTOCOL\n"
  "       PROTOCOL is a pair PROTOCOL_NAME={SIGNAL_NAMES}\n"
  "       SIGNAL_NAMES is a coma-separated list of SIGNAL_NAME\n"
  "  -ep, --extract-protocol PROTOCOL_NAMES list of set names to extract\n"
  "  -o1, --optimise-a PROTOCOL_NAMES   protocols to optimise by heuristic A\n"
  "  -o2, --optimise-ab PROTOCOL_NAMES  protocols to optimise by heuristics A,B\n"
  "  -o3, --optimise-abc PROTOCOL_NAMES protocols to optimise by heuristics A,B,C\n"
  "       Heuristic A - optimisation of choice\n"
  "       Heuristic B - latency optimisation\n"
  "       Heuristic C - size optimisation\n"
  "  -wp, --write-protocol PROTOCOL_NAMES list of set names to write\n"
  "  -ip, --implicit-places             show implicit places\n"
  "  -h,  --help                        print this help only\n"
  "  -v,  --version                     print version only\n";
const char* _protode_fmt_version =
  "Version %d.%d\n"
  "Last changed at %s\n"
  "Created by Danil Sokolov (E-mail: danil.sokolov@ncl.ac.uk, ICQ#: 30193190)\n"
  "Copyright (c) 2003, University of Newcastle, Newcastle upon Tyne, UK\n";

const int _protode_version_major = 1;
const int _protode_version_minor = 0;
const char* _protode_version_date = "31 May 2006";

//---------------------------------------------------------------------------
char* protode_get_help(char* name)
{
  int len = strlen (_protode_fmt_help) + 2 * strlen (name) + 1;
  char* help = new char [len];
  sprintf(help, _protode_fmt_help, name, name);
  return help;
}

//---------------------------------------------------------------------------
char* protode_get_version(char* name)
{
  int len = strlen (_protode_fmt_version) + strlen (_protode_version_date) + 1;
  char* version = new char [len];
  sprintf(version, _protode_fmt_version, _protode_version_major, 
    _protode_version_minor, _protode_version_date);
  return version;
}

