#include "stg_object.h"
#include "stg_transition.h"
#include "stg_place.h"
#include "stg_cluster.h"

//---------------------------------------------------------------------------
Cluster::Cluster(const char* _name, Type _type, Tag _tag, void* _data)
: Object(_name, tag, _data), type(_type)
{
  transitions = new TransitionArray(2);
  places = new PlaceArray(2);
}

//---------------------------------------------------------------------------
Cluster::Cluster(const Cluster& cluster)
: Object(cluster), type(cluster.type)
{
  transitions = new TransitionArray(*cluster.transitions);
  places = new PlaceArray(*cluster.places);
}

//---------------------------------------------------------------------------
Cluster::~Cluster()
{
  delete transitions; transitions = NULL;
  delete places; places = NULL;
}

