#ifndef _STG_GRAPH_CLUSTER_H_
#define _STG_GRAPH_CLUSTER_H_

#include <stdio.h>
#include "stg_object.h"
#include "stg_transition.h"
#include "stg_place.h"
#include "stg_cluster.h"
#include "stg_graph.h"

//---------------------------------------------------------------------------
class GraphCluster : public Graph
{
  public:
    GraphCluster(const char* _name = NULL, Tag _tag = TAG_UNDEFINED, void* _data = NULL);
    GraphCluster(const GraphCluster& graph_cluster);
    ~GraphCluster();

    bool addCluster(Cluster* cluster);
    void removeCluster(Cluster* cluster);
    Cluster* findCluster(const char* cluster_name) const;
    Cluster* findCluster(Object* object) const;
    void calcClusters();

  protected:
    ClusterArray* clusters;
    ClusterHashSet* cluster_hashset;
    
    char* guessClusterName(Cluster* cluster);
    char* genClusterName(const char* cluster_name);

    void calcClusterIncidence(Cluster* cluster);
    void findTransitionCluster(Cluster* cluster, Transition* transition);
    void findPlaceCluster(Cluster* cluster, Place* place);
    void calcClusterType(Cluster* cluster);
};

#endif
