#ifndef _STG_GRPAH_CLUSTER_DOT_H_
#define _STG_GRAPH_CLUSTER_DOT_H_

#include <stdio.h>
#include "stg_object.h"
#include "stg_transition.h"
#include "stg_place.h"
#include "stg_cluster.h"
#include "stg_graph_cluster.h"

//---------------------------------------------------------------------------
class GraphClusterDot : public GraphCluster
{
  public:
    GraphClusterDot(const char* _name = NULL, Tag _tag = TAG_UNDEFINED, void* _data = NULL);
    GraphClusterDot(const GraphClusterDot& graph_cluster_dot);
    ~GraphClusterDot();

    void writeDot(const char* file_name, int legend);

  protected:
    char* genDotModelLabel(const char* _label);
    char* genDotSignalLabel(Signal* signal);
    char* genDotTransitionLabel(Transition* transition);
    char* genDotPlaceLabel(Place* place);
    char* genDotTransitionVariable(Transition* transition);
    char* genDotPlaceVariable(Place* place);

    void writeDotSignals(FILE* file, Signal::Type type, const char* label);
    void writeDotLegend(FILE* file);
    void writeDotClusterProducingArcs(FILE* file, int cluster_index);
    void writeDotClusterConsumingArcs(FILE* file, int cluster_index);
    void writeDotClusterReadArcs(FILE* file, int cluster_index);
    void writeDotClusterTransitions(FILE* file, int cluster_index);
    void writeDotClusterPlaces(FILE* file, int cluster_index);
    void writeDotCluster(FILE* file, int cluster_index);
};

#endif
