#ifndef _STG_GRAPH_UTILS_H_
#define _STG_GRAPH_UTILS_H_

#include "array.h"
#include "stg_transition.h"
#include "stg_place.h"
#include "stg_graph.h"


extern void addConsumingArc(Place* place, Transition* transition);
extern void addConsumingArcs(PlaceArray* places, Transition* transition, Place* place_exclude = NULL);
extern void addConsumingArcs(Place* place, TransitionArray* transitions, Transition* transition_exclude = NULL);
extern void removeConsumingArc(Place* place, Transition* transition);
extern void removeConsumingArcs(PlaceArray* places, Transition* transition, Place* place_exclude = NULL);
extern void removeConsumingArcs(Place* place, TransitionArray* transitions, Transition* transition_exclude = NULL);
extern bool isConsumingArc(Place* place, Transition* transition);

extern void addProducingArc(Transition* transition, Place* place);
extern void addProducingArcs(TransitionArray* transitions, Place* place, Transition* transition_exclude = NULL);
extern void addProducingArcs(Transition* transition, PlaceArray* places, Place* place_exclude = NULL);
extern void removeProducingArc(Transition* transition, Place* place);
extern void removeProducingArcs(TransitionArray* transitions, Place* place, Transition* transition_exclude = NULL);
extern void removeProducingArcs(Transition* transition, PlaceArray* places, Place* place_exclude = NULL);
extern bool isProducingArc(Transition* transition, Place* place);

extern void addReadArc(Place* place, Transition* transition);
extern void addReadArcs(PlaceArray* places, Transition* transition, Place* place_exclude = NULL);
extern void addReadArcs(Place* place, TransitionArray* transitions, Transition* transition_exclude = NULL);
extern void removeReadArc(Place* place, Transition* transition);
extern void removeReadArcs(PlaceArray* places, Transition* transition, Place* place_exclude = NULL);
extern void removeReadArcs(Place* place, TransitionArray* transitions, Transition* transition_exclude = NULL);
extern bool isReadArc(Place* place, Transition* transition);

extern void swapTransitionsPreset(Transition* transition_1, Transition* transition_2);
extern void swapTransitionsPostset(Transition* transition_1, Transition* transition_2);
extern void swapTransitionsReadset(Transition* transition_1, Transition* transition_2);
extern void swapTransitions(Transition* transition_1, Transition* transition_2);

extern void swapPlacesPreset(Place* place_1, Place* place_2);
extern void swapPlacesPostset(Place* place_1, Place* place_2);
extern void swapPlacesReadset(Place* place_1, Place* place_2);
extern void swapPlaces(Place* place_1, Place* place_2);

#endif
