#include "messages.h"
#include "stg_object.h"
#include "stg_object_utils.h"

//---------------------------------------------------------------------------
void addObjectsTag(ObjectArray* objects, Tag tag)
{
  if (objects)
  {
    for (int object_index = 0; object_index < objects->count(); object_index++)
    {
      Object* object_cur = (*objects)[object_index];
      object_cur->addTag(tag);
    }
  }
}

//---------------------------------------------------------------------------
void removeObjectsTag(ObjectArray* objects, Tag tag)
{
  if (objects)
  {
    for (int object_index = 0; object_index < objects->count(); object_index++)
    {
      Object* object_cur = (*objects)[object_index];
      object_cur->removeTag(tag);
    }
  }
}

//---------------------------------------------------------------------------
bool testObjectsTagAll(ObjectArray* objects, Tag tag)
{
  bool result = true;
  if (objects)
  {
    for (int object_index = 0; object_index < objects->count(); object_index++)
    {
      Object* object_cur = (*objects)[object_index];
      if ( !object_cur->testTag(tag) )
      {
        result = false;
        break;
      }
    }
  }
  return result;
}

//---------------------------------------------------------------------------
bool testObjectsTagAny(ObjectArray* objects, Tag tag)
{
  bool result = false;
  if (objects)
  {
    for (int object_index = 0; object_index < objects->count(); object_index++)
    {
      Object* object_cur = (*objects)[object_index];
      if (object_cur->testTag(tag))
      {
        result = true;
        break;
      }
    }
  }
  return result;
}

//---------------------------------------------------------------------------
bool inObjectsTagAll(ObjectArray* objects, Tag tag)
{
  bool result = true;
  if (objects)
  {
    for (int object_index = 0; object_index < objects->count(); object_index++)
    {
      Object* object_cur = (*objects)[object_index];
      if ( !object_cur->inTag(tag) )
      {
        result = false;
        break;
      }
    }
  }
  return result;
}

//---------------------------------------------------------------------------
bool inObjectsTagAny(ObjectArray* objects, Tag tag)
{
  bool result = false;
  if (objects)
  {
    for (int object_index = 0; object_index < objects->count(); object_index++)
    {
      Object* object_cur = (*objects)[object_index];
      if (object_cur->inTag(tag))
      {
        result = true;
        break;
      }
    }
  }
  return result;
}
