#include "stg_object.h"
#include "stg_place.h"

//---------------------------------------------------------------------------
Place::Place(const char* _name, int _marking, Tag _tag, void* _data) 
: Object(_name, _tag, _data), marking(_marking)
{
  this->preset = new TransitionArray(1);
  this->postset =  new TransitionArray(1);
  this->readset =  new TransitionArray(1);
}

//---------------------------------------------------------------------------
Place::Place(const Place& place) 
: Object(place), marking(place.marking)
{
  this->preset = new TransitionArray(*place.preset);
  this->postset =  new TransitionArray(*place.postset);
  this->readset =  new TransitionArray(*place.readset);
}

//---------------------------------------------------------------------------
Place::~Place()
{
  delete preset; preset = NULL;
  delete postset; postset = NULL;
  delete readset; readset = NULL;
}
