#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "str_utils.h"

const char SYMBOL_UNDERSCORE = '_';
const char SYMBOL_NAME_SEP   = ',';
const char* NAME_STDIO       = "-";

//---------------------------------------------------------------------------
char* namecopy(const char* name)
{
  char* s = NULL;
  if (name)
  {
    int size = strlen(name) + 1;
    s = new char[size];
    memcpy(s, name, size*sizeof(char));
  }
  return s;
}

//---------------------------------------------------------------------------
char* name2pattern(const char* pattern, ...)
{
  va_list args;
  va_start(args, pattern);
  char* s = new char[20480*sizeof(char)];
  vsprintf(s, pattern, args);
  va_end(args);
  char* name_new = namecopy(s);
  delete [] s;
  return name_new;
}

//---------------------------------------------------------------------------
char* names2name(const char* names, int index)
{
  int count = 0;
  char* name = NULL;
  const char* name_start = names;
  while (name_start && (count < index))
  {
    count++;
    name_start = strchr(name_start, SYMBOL_NAME_SEP);
    if (name_start) name_start++;
  }
  if (name_start)
  {
    int len = 0;
    char* name_end = strchr(name_start, SYMBOL_NAME_SEP);
    if (name_end)
      len = name_end - name_start;
    else
      len = strlen(name_start);
    name = new char[len + 1];
    memcpy(name, name_start, len*sizeof(char));
    name[len] = '\0';
  }
  return name;
}

//---------------------------------------------------------------------------
int namescount(const char* names)
{
  int count = 0;
  const char* s = names;
  while (s)
  {
    count++;
    s = strchr(s, SYMBOL_NAME_SEP);
    if (s) 
      s++;
  }
  return count;
}

//---------------------------------------------------------------------------
int namecount(const char* names, const char* name)
{
  int count = 0;
  int name_index = 0;
  const char* name_cur = NULL;
  while (name_cur = names2name(names, name_index++))
  {
    if (strcmp(name_cur, name) == 0)
      count++;
    delete [] name_cur;
  }
  return count;
}
